#include "global.h"

/****************************************************************************\
 PROCEDURE: missiles.
 Receives the maximum number of missiles possibly in use, and the character
 used for the missiles. At present, missiles only reset by moving off the
 left hand side of the screen.

\****************************************************************************/

void missiles( number, type )
    int number;
    char type;
{
    int t;

    for ( t=0 ; t<number ; t++ ) {
	if ( missf[t] == 1 ) {
	    (void) vaddch ( (int) (missx[t]), (int) (missy[t]), ' ' );
	    missy[t] = missy[t] + missvy[t];
	    missx[t] = missx[t] + missvx[t];
	    if ( ( missx[t]>1 )&&( missy[t]>=1)&&( missy[t]<22 ) ) {
		(void) vaddch ( (int) (missx[t]), (int) (missy[t]), type );
	    }
	    else missf[t] = 0;
	}
    }
}

/****************************************************************************\
 FUNCTION: freemissile.
 Returns the smallest index of a free-missile. Returns -1 if there are none.
 Receives the maximum number of missiles *wanted* at this stage.

\****************************************************************************/

int freemissile( number )
    int number;
{
    int t;

    for ( t=0 ; t<number; t++ ) {
	if ( missf[t] == 0 ) return ( t );
    }
    return ( -1 );
}

/****************************************************************************\
 PROCEDURE: alienlaser.
 Fire the alien laser.

\****************************************************************************/

void alienlaser()
{
    int i, j, k, temp;

    for ( temp=0 ; temp<6 ; temp++ ) {
	k = rnd() / 1250;
	j = 1+Harvgunsy[k];
	for ( i=25+Harvgunsx[k] ; i>0 ; i-- ) {
	    (void) move ( j, i );
	    (void) addch ( '*' );
	}
	if ( j == y ) hit = 1;

	update();
	for ( i=25+Harvgunsx[k] ; i>0 ; i-- ) {
	    (void) move ( j, i );
	    (void) addch ( ' ' );
	}
    }
    monsterstate2 = 1;
    update();
}

/****************************************************************************\
 PROCEDURE: lightning.

\****************************************************************************/

void lightning ()
{
    int i, j, lx[22];

    j = rnd() / 125;
    for ( i=1 ; i<22 ; i++ ) {
	(void) move ( i , j );
	(void) addch ( '!' );
	lx[i] = j;
	j += rnd()/5000 - 1;
	if ( j<1 ) j = 1;
    }
    update();
    hit = checkship();
    for ( i=1 ; i<22 ; i++ ) {
	(void) move ( i , lx[i] );
	(void) addch ( ' ' );
    }

}


/****************************************************************************\
 PROCEDURE: actmonster.
 Do all the actions for the monsters depending on the stage.
 Do a printinfo occasionally.

\****************************************************************************/

void actmonster ()
{
    int i, j, k, t, frame, temp;

    if ( stageend == 1 ) return;
    switch ( stage ) {
    case 1:
	if ( stageend == 1 ) {
	    break;
	}

	for ( i=0 ; i<10 ; i++ ) {
	    (void) move ( monstery[0]+i , monsterx[0] );
	    (void) addstr ( flipship[monsterstate1][i] );
	}
	if ( rnd() < 850 ) {
	    monsterstate1 = 0;
	    monstery[0] += monsterstate2;
	    if ( ( monstery[0] < 3 ) || ( monstery[0] > 10 ) )
		monsterstate2 = -monsterstate2;
	    if ( rnd() < 3000 ) {
		monsterstate1 = 1;
		for ( i=0 ; i<4 ; i++ ) {
		    if ( ( temp = freemissile( 3 )) != -1 ) {
			missx[temp] = monsterx[0]+11;
			missy[temp] = monstery[0]+5;
			missvx[temp] = -((float) (rnd()+10000)/20000);
			missvy[temp] = ( (float) ( rnd() - 5000 ) / 30000 );
			missf[temp] = 1;
		    }
		}
	    }
	}
	missiles ( 3, 'o' );
	break;
    case 2:
	for ( i=0 ; i<NUMVOMIT ; i++ ) {
	    /* Dont blank it unless its on screen */
	    if ( monsterx[i] < 79 ) {
		(void) move ( monstery[i], monsterx[i] );
		(void) addch ( ' ' );
	    }
	    monstery[i]++;
	    monsterx[i]--;
	    if ( ( monsterx[i] < 2 ) || ( monstery[i] > 21 ) ) {
		/* .0098 = ( 78 + 20 ) / 10000 */
		monsterx[i] = ( 1+ rnd() * .0099 );
		monstery[i] = 1;
	    }
	    /* Only display if vomit is on screen! */
	    if ( monsterx[i] < 79 ) {
		(void) move ( monstery[i], monsterx[i] );
		(void) addch ( '@' );
	    }
	}
	break;

    case 3:
	monsterstate1++;
	monsterstate1 %= 4 * CHICKENRATE;
	frame = (int) ( monsterstate1 / CHICKENRATE );
	if ( rnd() < 300 ) {
	    monsterstate2++;
	    printinfo();
	    if ( monsterstate2 > 44 ) stageend = 1;
	    if ( ( temp = freemissile( 4 )) != -1 ) {
		missx[temp] = 45-monsterstate2;
		missy[temp] = 8;
		missvx[temp] = -2;
		missvy[temp] =( (float) ( rnd() - 5000 ) / 25000 );
		missf[temp] = 1;
	    }
	}

	for ( i=0 ; i<7 ; i++ ) {
	    (void) move ( i+6, 45-monsterstate2 );
	    (void) addstr ( chicken[frame][i] );
	}
	if ( monsterstate3 > CHICKENSTAMINA ) {
	    dissolve ( 45-monsterstate2, 75-monsterstate2, 6, 13 );
	    stageend = 1;
	    score += 2000;
	}
	missiles ( 4, '*' );
	break;

    case 4:
	for ( i=0 ; i<NUMCHICKS ; i++ ) {
	    for ( j=0 ; j<2 ; j++ ) {
		(void) move ( monstery[i]+j, monsterx[i] );
		(void) addstr ( "   " );
	    }
	    monstery[i] += (rnd()-5000)/4500;
	    monsterx[i] -= 2;
	    if ((monsterx[i]<1)||(monstery[i]<1)||(monstery[i]>20) ) {
		monsterx[i] = 73;
		monstery[i] = rnd() / 500 + 1;
	    }
	    for ( j=0 ; j<2 ; j++ ) {
		(void) move ( monstery[i]+j, monsterx[i] );
		(void) addstr ( chick[j] );
	    }
	    if ( rnd() < 500 ) {
		if ( ( temp = freemissile( NUMDROPPINGS ) ) != -1 ) {
		    j = rnd()/5000;
		    missx[temp] = monsterx[j];
		    missy[temp] = monstery[j];
		    missvx[temp] = -1;
		    missvy[temp] = 0;
		    missf[temp] = 1;
		}
	    }
	}
	missiles ( NUMDROPPINGS, '.' );
	break;

    case 5:
	i = (int) (rnd() * NUMTRIBBLES / 10000 );
	for ( j=0 ; j<2 ; j++ ) {
	    (void) move ( monstery[i]+j, monsterx[i] );
	    (void) addstr ( "    " );
	}
	monsterx[i]--;
	if ( monsterx[i] < x ) monsterx[i] +=2;
	monstery[i] += ( rnd()-5000 )/4000;
	if ( monsterstate2 == 1 ) {
	    monstery[i]++;
	    if ( monstery[i] > y ) monstery[i] -=2;
	}
	if ((monstery[i]<1)||(monstery[i]>20)) {
	    monstery[i] = (rnd() / 500) + 2;
	    monsterx[i] = 70;
	}

	for ( j=0 ; j<2 ; j++ ) {
	    (void) move ( monstery[i]+j, monsterx[i] );
	    (void) addstr ( tribble[monsterstate2][j] );
	}
	break;

    case 6:
	if ( monsterstate1 > 800 ) stageend = 1;
	if ( ( temp = freemissile( NUMAST ) ) != -1 ) {
	    missy[temp] = (int) ( rnd() / 460 );
	    missx[temp] = 78;
	    missvy[temp] = ( (float) ( rnd() - 5000 ) / 35000 );
	    missvx[temp] = -( (float) ( rnd() ) /10000 + 2 );
	    missf[temp] = 1;
	}
	missiles ( NUMAST , 'O' );
	score += 6;
	monsterstate1++;
	break;

    case 7:
	if ( monsterstate2 > THINGSTRENGTH ) {
	    explode ( 17, 48, 40 );
	    dissolve ( 30, 60, 2, 21 );
	    stageend = 1;
	    break;
	}
	frame = (int) ( monsterstate1 / MIRKALIENSPEED );
	if ( monsterstate3 == MIRKALIENSPEED*15 - 4 ) {
	    monsterstate1++;
	    if ( monsterstate1 == MIRKALIENSPEED*15 - 4 )
		monsterstate3 = MIRKALIENSPEED*11 + 4;
	}
	else {
	    monsterstate1--;
	    if ( monsterstate1 == MIRKALIENSPEED*11+4 ) {
		monsterstate3 = MIRKALIENSPEED*15-4;
		/* initialise the random tongue */
		monsterc[0] = '_';
		for ( i=1 ; i<20 ; i++ ) {
		    monsterx[i] = monsterx[i-1] - 1;
		    monstery[i] = monstery[i-1];
		    monsterc[i] = '_' ;
		    if ( rnd() < 3000 ) {
			monsterc[i-1] = '\\';
			monstery[i]--;
		    }
		}
	    }
	}
	for ( i=0 ; i<20 ; i++ ) {
	    (void) move ( i+2, 5 );
	    (void) addstr ( MirkAlien[frame][i] );
	}
	j = (monsterstate1 - 11*MIRKALIENSPEED -12);
	if ( j>0 ) {
	    for ( i=0 ; i<j ; i++ ) {
		(void) move ( monstery[i], monsterx[i] );
		(void) addch ( monsterc[i] );
	    }
	}
	if ( ( ( temp = freemissile( 2 ) ) != -1 ) && ( rnd() < 500 ) ) {
	    missx[temp] = 36;
	    missy[temp] = 10;
	    missvx[temp] = -0.90;
	    missvy[temp] = ( y - 10 ) / ( 36 - x + 0.5 );
	    missf[temp] = 1;
	}

	missiles ( 2, '*' );
	break;

    case 8:
	if ( monsterstate2 >= 4 ) {
	    stageend = 1;
	    score += 2000;
	    dissolve ( monsterx[0], monsterx[0] + 30,
		       monstery[0], monstery[0] + 12 );
	    break;
	}
	for ( i=0 ; i<11 ; i++ ) {
	    (void) move ( monstery[0]+i, monsterx[0] );
	    (void) addstr ( spider[monsterstate1][i] );
	}
	if ( rnd() < 1000 ) monsterstate1 = 1-monsterstate1;
	if ( (temp = freemissile( 3 ) ) != -1 ) {
	    missx[temp] = monsterx[0] + 21;
	    missy[temp] = monstery[0] + 5;
	    missvx[temp] = -((float) (rnd()+5000)/10000);
	    missvy[temp] = 0;
	    missf[temp] = 1;
	    if ( (rnd()<3000) &&( monsterx[0]>10) ) {
		monsterx[0]--;
	    }
	}
	missiles ( 3, '&' );
	break;

    case 9:
	if ( monsterstate2 > LIMGUIDED ) {
	    stageend = 1;
	    break;
	}
	for ( i=0 ; i<NUMSALVOS ; i++ ) {
	    (void) move ( monstery[i], monsterx[i] );
	    (void) addstr ( "  " );
	    monsterx[i] -= 2;
	    if ( rnd() < 1000 ) {
		monstery[i]--;
		if ( monstery[i] < y ) monstery[i]+=2;
		if ( rnd() < 1000 ) {
		    if ( (temp = freemissile( NUMGUIDED )) != -1 ) {
			missx[temp] = monsterx[i];
			missy[temp] = monstery[i];
			missvx[temp] = -1;
			missvy[temp] = rnd()/40000 - .125;
			missf[temp] = 1;
		    }
		}
	    }
	    if ( monsterx[i] < 1 ) {
		monsterx[i] = 77 - rnd()/2000;
		monstery[i] = 1 + rnd()/500 ;
	    }
	    (void) move ( monstery[i], monsterx[i] );
	    (void) addstr( "-<" );
		    missiles ( NUMGUIDED , '.' );
	}
	break;

    case 10:
	if ( monsterstate3 == 1 ) {
	    dissolve ( 20, 54, 6, 22 );
	    stageend = 1;
	    break;
	}
	for ( i=0 ; i<12 ; i++ ) {
	    (void) move ( i+10 , 20 );
	    (void) addstr ( powerstation[monsterstate1][i] );
	}
	if ( monsterstate1 == 1 ) {
	    for ( i=18-monsterstate2 ; i<23-monsterstate2 ; i++ ) {
		if ( i<20 && i>0 ) {
		    (void) move ( i , 35 );
		    (void) addstr ( "(<||>)" );
		}
	    }
	    if ( 23-monsterstate2 < 20 ) {
		(void) move ( 23-monsterstate2 , 35 );
		(void) addstr ( "      " );
	    }
	    if ( monsterstate2++ == 49 ) monsterstate2 = 0;
	}
	if ( rnd() < 100 ) lightning();
	break;

    case 11:
	for ( i=0 ; i<NUMPLANTS ; i++ ) {
	    if ( monsterstate1 == i ) {
		if ( rnd() < 2000 ) monsterc[i]++;
		if ( monsterc[i] == 5 ) {
		    for ( j=0 ; j<NUMPOLLEN ; j++ ) {
			if ( (temp = freemissile( NUMPOLLEN )) != -1 ) {
			    missx[temp] = monsterx[i] -2 + rnd()/600;
			    missy[temp] = monstery[i] - rnd()/2000;
			    missvx[temp] = -1;
			    missvy[temp] =(y-missy[temp])/(0.5+missx[temp]-x);
			    missvy[temp] += (rnd()/20000.0 - 0.25);
			    missf[temp] = 1;
			}
		    }
		    monsterc[i] = 4;
		    monsterstate1 = -1;
		}
	    }
	    else {
		if ( (rnd() < 250) && (monstery[i]>7) ) monstery[i]--;
	    }
	    if ( (monsterstate1 == -1) && ( rnd()<30) )
		monsterstate1 = rnd() * NUMPLANTS / 10000;
		for ( j=0 ; j<5 ; j++ ) {
		(void) move ( monstery[i]+j , monsterx[i] );
		(void) addstr ( plant[monsterc[i]][j] );
	    }
	    for ( j=monstery[i]+5 ; j<21 ; j++ ) {
		(void) move ( j, monsterx[i]+4 );
		(void) addstr ( "| |" );
	    }
	}
	missiles ( NUMPOLLEN , '+' );
	break;

    case 12:
	for ( i=0 ; i<NUMVOMIT-2 ; i++ ) {
	    /* Dont blank it unless its on screen */
	    if ( monsterx[i] < 79 ) {
		(void) move ( monstery[i], monsterx[i] );
		(void) addch ( ' ' );
	    }
	    monstery[i]++;
	    monsterx[i]--;
	    if ( ( monsterx[i] < 2 ) || ( monstery[i] > 21 ) ) {
		/* .0098 = ( 78 + 20 ) / 10000 */
		monsterx[i] = ( 1+ rnd() * .0099 );
		monstery[i] = 1;
		if ( rnd() < 2200 ) lightning();
		if ( (temp = freemissile( NUMSIDEVOMIT ) ) != -1 ) {
		    missx[temp] = 78;
		    missy[temp] = 1 + rnd()/500;
		    missvx[temp] = -2;
		    missvy[temp] = rnd()/20000.0 -.25;
		    missf[temp] = 1;
		}
	    }
	    /* Only display if vomit is on screen! */
	    if ( monsterx[i] < 79 ) {
		(void) move ( monstery[i], monsterx[i] );
		(void) addch ( '@' );
	    }
	}
	missiles ( NUMSIDEVOMIT, '*' );
	break;

    case 13:
	if ( monsterstate2 > 9 ) {
	    stageend = 1;
	    explode ( 13, 55, 40 );
	    break;
	}
	if ( monsterstate1 < HARVSHIPSPEED*12-1 ) monsterstate1++;
	frame = 11 - monsterstate1 / HARVSHIPSPEED ;
	for ( i=0 ; i<20 ; i++ ) {
	    (void) move ( i+1, 25 );
	    (void) addstr ( Harvship[frame][i] );
	}
	hit = checkship();
	if (( frame == 0 ) && ( ( temp = freemissile(HARVBULLETS) ) != -1 )
	    && (rnd()<2000)) {
	    missx[temp] = 25;
	    missy[temp] = 11;
	    missvx[temp] = -1;
	    j = x;
	    if ( j>14 ) j = 14;
	    missvy[temp] = (y-11)/(0.5+25-j) + rnd()/20000.0 -0.25;
	    missf[temp] = 1;
	    if ( rnd() < 500 ){
		monsterstate1 -= 1.9*HARVSHIPSPEED;
		monsterstate2 = 0;
		frame = 1;
	    }
	}
	if ( (frame == 0) && (monsterstate2 ==0) ) alienlaser();

	missiles ( HARVBULLETS, 'o' );
	break;

    case 14:
	if ( monsterstate2 >= FISHLIM ) {
	    dissolve ( monsterx[0]-30, monsterx[0],
		       monstery[0], monstery[0]+6 );
	    monsterstate1 = monsterstate2 = 0;
	    monsterstate3++;
	    break;
	}
	if ( monsterstate3 == KILLFISH ) stageend = 1;
	if ( monsterx[0] == 78 )  {
	    dissolve ( monsterx[0]-30, monsterx[0],
                       monstery[0], monstery[0]+6 );
	    monsterstate1 = monsterstate2 = 0;
	}
	if ( monsterstate1 == 1 ) {
	    if ( rnd() < 1500 ) {
		j = monsterx[0];
		if ( j>30 ) j = 30;
		for ( i=0 ; i<6 ; i++ ) {
		    for ( k=0 ; k<j ; k++ ) {
			(void) move ( monstery[0]+i, monsterx[0]-k );
			(void) addch ( dogfish[i][30-k] );
		    }
		}
		monsterx[0]++;
	    }
	}
	else {
	    if ( rnd() < 600 ) {
		monsterx[0] = 1;
		monstery[0] = rnd()/1000 + 3;
		monsterstate1 = 1;
	    }
	}
	break;

    case 15:
	shield = 0;
	hit = 1;
	break;

    default:
	(void) usleep ( 10000 );
    }
}
